#define BUFSIZE 80
#define MAXSIZE 255
#include<stdio.h>
#include<string.h>
#include<sys/types.h>
#include<sys/dir.h>
#include<unistd.h>
#include<sys/stat.h>
#include<stdlib.h>
/*********************************************************
Assignment #4 - Search 2				match()
By: Andrew Scheel
Date: 10/28/1999

Purpose: display file info. The output is the complete path 
		 and file name terminated by a colon, the type of
		 file, the owners file permissions, the size and
		 date and time.
IN:
	struct direct directory pointer
OUT:
	none

Pseudocode:
	DISPLAY path and file name
	DISPLAY type of file
	DISPLAY owner permisions
	DISPLAY file size
	DISPLAY date last modified
*********************************************************/
void printinfo(struct direct *dp)
{
	struct stat statbuf;                            //for lstat structure
	char *pfname = NULL;						    //path and file name
	struct tm *ftime;                               //time structure
	char *ftimestr= malloc(sizeof(char) * BUFSIZE); //string for time
	
	pfname = getcwd(NULL, MAXSIZE+1);
	pfname = strcat(pfname, "/");
	pfname = strcat(pfname, dp->d_name);

	//print path  and filename
	printf("%s: ", pfname);

	//get all info on the file
	lstat(pfname, &statbuf);
	
	//type of file
	if(S_ISREG(statbuf.st_mode))
	{
		printf("FILE ");
	}
	else if(S_ISDIR(statbuf.st_mode))
	{
		printf("DIRECTORY ");
	}
	else if(S_ISLNK(statbuf.st_mode))
	{
		printf("LINK ");
	}
	else
	{
		printf("OTHER ");	
	}

	// permisions
	if(access(pfname,R_OK) == 0)
		printf("R");
	else
		printf("-");
	if(access(pfname,W_OK) == 0)
		printf("W");
	else
		printf("-");
	if(access(pfname,X_OK) == 0)
		printf("X ");
	else
		printf("- ");

	//size
	printf("%ld ", (long)statbuf.st_size);

	//time
	ftime = localtime(&statbuf.st_mtime);
	strftime(ftimestr, BUFSIZE, "%b %d %X", ftime);
	printf("%s\n", ftimestr);
	free(ftimestr);
	free(pfname);
}
